#[doc = "Register `TIM1` reader"]
pub type R = crate::R<Tim1Spec>;
#[doc = "Register `TIM1` writer"]
pub type W = crate::W<Tim1Spec>;
#[doc = "Field `DAWE` reader - Days of Week Time Value"]
pub type DaweR = crate::FieldReader;
#[doc = "Field `DAWE` writer - Days of Week Time Value"]
pub type DaweW<'a, REG> = crate::FieldWriter<'a, REG, 3>;
#[doc = "Field `MO` reader - Month Time Value"]
pub type MoR = crate::FieldReader;
#[doc = "Field `MO` writer - Month Time Value"]
pub type MoW<'a, REG> = crate::FieldWriter<'a, REG, 4>;
#[doc = "Field `YE` reader - Year Time Value"]
pub type YeR = crate::FieldReader<u16>;
#[doc = "Field `YE` writer - Year Time Value"]
pub type YeW<'a, REG> = crate::FieldWriter<'a, REG, 16, u16>;
impl R {
    #[doc = "Bits 0:2 - Days of Week Time Value"]
    #[inline(always)]
    pub fn dawe(&self) -> DaweR {
        DaweR::new((self.bits & 7) as u8)
    }
    #[doc = "Bits 8:11 - Month Time Value"]
    #[inline(always)]
    pub fn mo(&self) -> MoR {
        MoR::new(((self.bits >> 8) & 0x0f) as u8)
    }
    #[doc = "Bits 16:31 - Year Time Value"]
    #[inline(always)]
    pub fn ye(&self) -> YeR {
        YeR::new(((self.bits >> 16) & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Bits 0:2 - Days of Week Time Value"]
    #[inline(always)]
    #[must_use]
    pub fn dawe(&mut self) -> DaweW<Tim1Spec> {
        DaweW::new(self, 0)
    }
    #[doc = "Bits 8:11 - Month Time Value"]
    #[inline(always)]
    #[must_use]
    pub fn mo(&mut self) -> MoW<Tim1Spec> {
        MoW::new(self, 8)
    }
    #[doc = "Bits 16:31 - Year Time Value"]
    #[inline(always)]
    #[must_use]
    pub fn ye(&mut self) -> YeW<Tim1Spec> {
        YeW::new(self, 16)
    }
}
#[doc = "RTC Time Register 1\n\nYou can [`read`](crate::generic::Reg::read) this register and get [`tim1::R`](R).  You can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero) this register using [`tim1::W`](W). You can also [`modify`](crate::generic::Reg::modify) this register. See [API](https://docs.rs/svd2rust/#read--modify--write-api)."]
pub struct Tim1Spec;
impl crate::RegisterSpec for Tim1Spec {
    type Ux = u32;
}
#[doc = "`read()` method returns [`tim1::R`](R) reader structure"]
impl crate::Readable for Tim1Spec {}
#[doc = "`write(|w| ..)` method takes [`tim1::W`](W) writer structure"]
impl crate::Writable for Tim1Spec {
    type Safety = crate::Unsafe;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: u32 = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: u32 = 0;
}
#[doc = "`reset()` method sets TIM1 to value 0"]
impl crate::Resettable for Tim1Spec {
    const RESET_VALUE: u32 = 0;
}
