#[doc = "Register `DAINTMSK` reader"]
pub type R = crate::R<DaintmskSpec>;
#[doc = "Register `DAINTMSK` writer"]
pub type W = crate::W<DaintmskSpec>;
#[doc = "Field `InEpMsk` reader - IN EP Interrupt Mask Bits"]
pub type InEpMskR = crate::FieldReader<u16>;
#[doc = "Field `InEpMsk` writer - IN EP Interrupt Mask Bits"]
pub type InEpMskW<'a, REG> = crate::FieldWriter<'a, REG, 16, u16>;
#[doc = "Field `OutEpMsk` reader - OUT EP Interrupt Mask Bits"]
pub type OutEpMskR = crate::FieldReader<u16>;
#[doc = "Field `OutEpMsk` writer - OUT EP Interrupt Mask Bits"]
pub type OutEpMskW<'a, REG> = crate::FieldWriter<'a, REG, 16, u16>;
impl R {
    #[doc = "Bits 0:15 - IN EP Interrupt Mask Bits"]
    #[inline(always)]
    pub fn in_ep_msk(&self) -> InEpMskR {
        InEpMskR::new((self.bits & 0xffff) as u16)
    }
    #[doc = "Bits 16:31 - OUT EP Interrupt Mask Bits"]
    #[inline(always)]
    pub fn out_ep_msk(&self) -> OutEpMskR {
        OutEpMskR::new(((self.bits >> 16) & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Bits 0:15 - IN EP Interrupt Mask Bits"]
    #[inline(always)]
    #[must_use]
    pub fn in_ep_msk(&mut self) -> InEpMskW<DaintmskSpec> {
        InEpMskW::new(self, 0)
    }
    #[doc = "Bits 16:31 - OUT EP Interrupt Mask Bits"]
    #[inline(always)]
    #[must_use]
    pub fn out_ep_msk(&mut self) -> OutEpMskW<DaintmskSpec> {
        OutEpMskW::new(self, 16)
    }
}
#[doc = "Device All Endpoints Interrupt Mask Register\n\nYou can [`read`](crate::generic::Reg::read) this register and get [`daintmsk::R`](R).  You can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero) this register using [`daintmsk::W`](W). You can also [`modify`](crate::generic::Reg::modify) this register. See [API](https://docs.rs/svd2rust/#read--modify--write-api)."]
pub struct DaintmskSpec;
impl crate::RegisterSpec for DaintmskSpec {
    type Ux = u32;
}
#[doc = "`read()` method returns [`daintmsk::R`](R) reader structure"]
impl crate::Readable for DaintmskSpec {}
#[doc = "`write(|w| ..)` method takes [`daintmsk::W`](W) writer structure"]
impl crate::Writable for DaintmskSpec {
    type Safety = crate::Unsafe;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: u32 = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: u32 = 0;
}
#[doc = "`reset()` method sets DAINTMSK to value 0"]
impl crate::Resettable for DaintmskSpec {
    const RESET_VALUE: u32 = 0;
}
